<template>
  <div>
    <div v-if="counter || moderate" class="media__info">
      <div v-if="counter" class="feed-info__title">
        {{ data.length }} images
      </div>
      <Button
        v-if="moderate"
        icon
        variant="none"
        size="inline"
        @click="onClickMediaEdit"
      >
        <svg-icon v-if="MediaEditCheckBox == false" name="pencil" />
        <svg-icon v-else name="close" />
      </Button>
      <Button
        v-if="MediaEditList.length == 1 && (type == 'event' || type == 'album')"
        size="small"
        variant="grey"
        style="
          width: auto;
          display: inline-flex;
          font-size: 16px;
          padding: 11px 25px;
          border-radius: 3px;
          text-transform: uppercase;
          font-weight: 600;
        "
        @click="updateCover"
      >
        {{ $t('buttons.set_cover') }}
      </Button>
    </div>

    <el-checkbox-group :class="`media ${variant}`" v-model="MediaEditList">
      <div
        v-for="(item, itemIndex) in data"
        :key="itemIndex"
        class="media__item"
      >
        <div class="media__checkbox" v-if="MediaEditCheckBox !== false">
          <el-checkbox :label="item.id">+</el-checkbox>
        </div>
        <div
          class="media__loop"
          v-if="MediaEditCheckBox === false"
          @click="index = itemIndex"
        ></div>
        <blur-hash-image
          v-if="item.blurhash"
          class="blurhash"
          :hash="item.blurhash"
          :src="`/storage/${item.preview_url}`"
        />
        <img
          v-else-if="item.preview_url"
          :src="`/storage/${item.preview_url}`"
        />
        <span v-else>loading</span>
      </div>
    </el-checkbox-group>

    <CoolLightBox
      :items="gallery(data)"
      :index="index"
      @close="index = null"
    ></CoolLightBox>

    <div v-if="MediaEditList.length" class="media__editor">
      <button class="feed-delete" @click="deleteMediaItems(MediaEditList)">
        <span>{{ $t('buttons.delete') }}</span>
        <svg-icon name="delete" />
      </button>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, useContext } from '@nuxtjs/composition-api'

import {
  useDeleteMediaMutation,
  useUpdateCoverAlbumMutation,
  useUpdateCoverEventMutation
} from '@/sdk/hooks'
import Button from '@/components/ui/Button.vue'
import elCheckbox from '@/components/element/Checkbox.vue'

// @ts-ignore TODO
import CoolLightBox from 'vue-cool-lightbox'
import '@/assets/scss/vue-cool-lightbox.scss'

export default defineComponent<{
  data: any
  variant: string
  type: string
  moderate: boolean | false
  counter: boolean | false
}>({
  props: ['data', 'variant', 'moderate', 'counter', 'type'],
  head: {},
  components: { Button, elCheckbox, CoolLightBox },
  setup(props, { root }) {
    const { app } = useContext()
    const MediaEditCheckBox = ref(false)
    const MediaEditList = ref([])
    const onClickMediaEdit = () => {
      if (MediaEditCheckBox.value !== false) {
        MediaEditCheckBox.value = false
        MediaEditList.value = []
      } else {
        MediaEditCheckBox.value = true
      }
    }

    const { mutate: deleteMutate } = useDeleteMediaMutation({})
    const deleteMediaItems = async (items: any) => {
      try {
        await items.forEach((i: any) => {
          deleteMutate({ id: i })
        })
      } finally {
        root.$message.error('Delete done')
        MediaEditCheckBox.value = false
        MediaEditList.value = []
      }
    }

    const index = ref(null)
    const gallery = (media: any) => {
      return media.map(function (item: any) {
        return {
          src: `/storage/${item.preview_url}`
          // src: ''
        }
      })
    }

    const { mutate: UpdateAlbumMutate } = useUpdateCoverAlbumMutation({})
    const { mutate: UpdateEventMutate } = useUpdateCoverEventMutation({})
    const updateCover = async () => {
      try {
        if (props.type == 'album') {
          await UpdateAlbumMutate({
            id: root.$route.params.id as string,
            object: {
              cover_media_file_id: MediaEditList.value[0]
            }
          })
        } else if (props.type == 'event') {
          await UpdateEventMutate({
            id: root.$route.params.id as string,
            object: {
              cover_media_file_id: MediaEditList.value[0]
            }
          })
        }
      } catch (err) {
        root.$message.error('Ой, попробуйте еще раз, пожалуйста')
      } finally {
        root.$message.success('Обложка обновлена')
        MediaEditCheckBox.value = false
        MediaEditList.value = []
      }
    }

    return {
      MediaEditList,
      MediaEditCheckBox,
      onClickMediaEdit,
      deleteMediaItems,
      gallery,
      index,
      updateCover
    }
  }
})
</script>

<style lang="scss" scoped>
@import '~/assets/scss/variables';

.feed {
  &-delete {
    background: $--color-danger;
    box-shadow: 0px 3px 6px #00000029;
    border: 0px;
    outline: none;
    border-radius: 3px;
    letter-spacing: 0.8px;
    color: $--color-bg;
    font-weight: bold;
    text-transform: uppercase;
    font-size: 16px;
    line-height: 20px;
    cursor: pointer;

    width: 50px;
    height: 50px;
    display: flex;
    align-items: center;
    justify-content: center;
    svg {
      display: block;
      width: 18px;
      height: 18px;
      fill: #fff;
    }
    span {
      display: none;
    }
    @media (min-width: 991.98px) {
      padding: 20px 40px;
      min-width: 300px;
      width: auto;
      height: auto;
      svg {
        display: none;
      }
      span {
        display: block;
      }
    }
  }
}

.media {
  display: grid;
  grid-template-columns: repeat(12, 1fr);
  grid-template-rows: repeat(2, 1fr);
  grid-gap: 2px;
  font-size: 0px;
  margin-left: -30px;
  margin-right: -30px;
  $self: &;
  @media (min-width: 1199.98px) {
    margin-left: 0px;
    margin-right: 0px;
    margin-bottom: 0px;
    grid-gap: 10px;
  }
  &__info {
    font-size: 0px;
    display: flex;
    align-items: center;
    margin-bottom: 30px;
    & > * {
      margin-right: 30px;
      &:last-child {
        margin-right: 0px;
      }
    }
    > div {
      font-size: 32px;
      line-height: 35px;
      color: #ffffff;
      margin-right: 30px;
    }
    ::v-deep .btn[icon] {
      width: 45px;
      height: 45px;
      border-radius: 50%;
      background: #272c3b;
      padding: 0px;
      flex: none;

      svg {
        fill: #00ffb3;
        width: 13px;
        height: 13px;
      }
    }
  }
  &__editor {
    position: fixed;
    left: 50%;
    transform: translateX(-50%);
    bottom: 30px;
    display: flex;
    justify-content: center;
    z-index: 999;
    > * {
      margin-left: 5px;
      margin-right: 5px;
    }
  }
  &__loop {
    position: absolute;
    left: 0px;
    right: 0px;
    top: 0px;
    bottom: 0px;
    z-index: 99;
  }
  &__checkbox {
    position: absolute;
    left: 0px;
    right: 0px;
    top: 0px;
    bottom: 0px;
    display: flex;
    font-size: 0px;
    z-index: 99;
    ::v-deep {
      .el-checkbox {
        margin: 0px;
        padding: 0px;
        font-size: 0px;
        display: flex;
        align-items: flex-start;
        justify-content: flex-end;
        flex: 1;
        padding: 15px;
        &__inner {
          margin: 0px;
          &::after {
            border: 2px solid #495271;
            border-left: 0;
            border-top: 0;
          }
        }
        &__label {
          display: none;
        }
        &__input.is-checked {
          .el-checkbox__inner {
            background-color: #00ffb3;
          }
        }
      }
    }
  }
  &__item {
    grid-column: span 4;
    grid-row: span 1;
    display: flex;
    position: relative;
    background: #272c3b;
    border-radius: 2px;
    overflow: hidden;
    &::v-deep {
      .blurhash {
        flex: 1;
      }
      img {
        object-fit: cover;
        width: 100%;
        height: 180px;
        @media (min-width: 1199.98px) {
          height: 280px;
        }
      }
    }

    @media (min-width: 1199.98px) {
      grid-column: span 3;
      grid-row: span 1;
      &:nth-child(10n + 1),
      &:nth-child(10n + 8) {
        grid-column: span 6;
        grid-row: span 2;
      }
    }
  }

  &.large {
    #{ $self }__item {
      @media (min-width: 1199.98px) {
        grid-column: span 3;
        grid-row: span 1;
        &:nth-child(12n + 1),
        &:nth-child(12n + 7) {
          grid-column: span 6;
          grid-row: span 2;
        }
        &:nth-child(12n + 2),
        &:nth-child(12n + 5) {
          grid-column: span 3;
          grid-row: span 2;
        }
      }
    }
  }
}
</style>
